var params = {};

async function fetchParams() {
    params = {};

    var searchParams = document.location.search.substring(1).split('&');
    searchParams.forEach(addParam);

    var hashParams = document.location.hash.substring(1).split('&');
    hashParams.forEach(addParam);

    document.querySelector('#featureId').innerText = params.entity_ids;
    const feature = await getFeature(params.entity_ids.split(',')[0]);
    document.querySelector('#featureName').innerText = feature.name;
    document.querySelector('#wsjfCOD').innerText = feature.wsjf_cod;
    document.querySelector('#wsjfJobSize').value = feature.job_size;
}

function addParam(paramsPair) {
    if (!paramsPair) {
        return;
    }

    const pair = paramsPair.split('=');
    var name = pair[0];
    var value = decodeURIComponent(pair[1]);

    params[name] = value;
}

async function getFeature(featureId) {
    const response = await fetch(`${params.octane_url}/api/shared_spaces/${params.shared_space}/workspaces/${params.workspace}/work_items/${featureId}?fields=name,wsjf_cod,rroe,job_size`);
    const feature = await response.json();
    return feature;
}

window.updateFeature = function updateFeature() {
    const featureId = params.entity_ids.split(',')[0];
    const feature = {
        job_size: Number(document.querySelector('#wsjfJobSize').value),
    };

    doUpdate(featureId, feature).then(() => {
		updateList([featureId]);
	});
}

async function doUpdate(featureId, featureData) {
    const cookieValue = document.cookie
        .split('; ')
        .find(row => row.startsWith('XSRF_COOKIE='))
        .split('=')[1];

    await fetch(
		params.octane_url +
        '/api/shared_spaces/' +
        params.shared_space +
        '/workspaces/' +
        params.workspace +
        '/work_items/' +
        featureId,
        {
            headers: {
                'content-type': 'application/json',
                'XSRF-HEADER': cookieValue,
            },
            body: JSON.stringify(featureData) ,
            method: 'PUT',
            credentials: 'include',
        }
    );
}

function updateList(entity_ids) {
    var message = {
        event_name: 'octane_refresh_entity',
        workspace: params.workspace,
        shared_space: params.shared_space,
        data: {
            entity_type: 'feature',
            entity_ids: entity_ids,
        },
    };
    window.parent.postMessage(message, '*');
}

window.onhashchange = fetchParams;
fetchParams();